<script setup>
import { toLarge } from '@/util/format';
import { computed, toRaw } from 'vue';
import { gameEvents } from '../../events';
import { useRollOver } from '../../store/popups';
import Progress from '../components/progbar.vue';

/**
* @property {boolean} active - true if skill is the active skill.
*/
const props = defineProps(['skill', 'active', 'state']);
const emits = defineEmits(['train']);

const { itemOver } = useRollOver();

const exp = computed(() => {
	return toLarge(Math.floor(props.skill.exp.value));
});
const length = computed(() => {
	return toLarge(Math.floor(props.skill.length.value));
});

</script>

<template>

	<div class="skill">

		<span class="separate" @mouseenter.capture.stop="itemOver($event, skill)">
			<span>{{ skill.name }}</span>
			<span class="flex-row" v-if="skill.owned">
				{{ 'Level: ' +
					Math.floor(skill.valueOf()) +
					'/' + (Math.trunc(toRaw(skill).max * 10) / 10).toFixed(1)
				}}
				<button class="train-btn"
			@click="emits('train', skill)" :disabled="!skill.canUse(state)">
				{{ active ? 'Stop' : 'Train' }}</button></span>

			<span v-else>
				<button @click="gameEvents.emit('buy', skill)"
					:disabled="!skill.canUse(state)">🔒</button>
			</span>
		</span>

		<div v-if="skill.owned">

		<Progress :value="skill.exp.value" :max="skill.length.value" hide-stats=true />
			exp: {{ exp + ' / ' + length }}
		</div>

	</div>

</template>